package com.example.calculator;

import androidx.appcompat.app.AppCompatActivity;

import android.os.Bundle;
import android.view.View;
import android.widget.Button;
import android.widget.TextView;

import com.example.calculator.model.*;

public class MainActivity extends AppCompatActivity {

    private TextView txtResult;
    private Calculator calc;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        txtResult = findViewById(R.id.txtResult);

        if (savedInstanceState != null){
            calc = new Calculator(savedInstanceState);
            txtResult.setText(calc.getDisplayedText());
        } else {
            calc = new Calculator();
        }
    }

    public void clickOperation(View view) {
        char c = ((Button)view).getText().charAt(0);
        if ('0' <= c && c <= '9'){
            calc.addDigit(c - '0');
        } else {
            switch (c){
                case '=': calc.doEqual(); break;
                case 'C': calc.clear(); break;
                default:
                    Operator o = Operator.getOperator(c);
                    if (o != null) calc.setOperator(o); break;
            }
        }
        txtResult.setText(calc.getDisplayedText());
    }

    @Override
    protected void onSaveInstanceState(Bundle outState) {
        super.onSaveInstanceState(outState);
        calc.onSaveInstanceState(outState);
    }
}