package com.example.calculator.model;

import android.os.Bundle;

public class Calculator {
    private int leftOperand, rightOperand;
    private Operator operator;

    public Calculator(){ clear(); }

    public Calculator(Bundle state) {
        leftOperand = state.getInt("leftOperand");
        rightOperand = state.getInt("rightOperand");
        operator = Operator.getOperator(state.getChar("operator"));
    }

    public void clear(){
        operator = null;
        leftOperand = 0;
        rightOperand = 0;
    }

    public void addDigit(int digit){
        rightOperand = rightOperand * 10 + digit;
    }

    public void setOperator(Operator op){
        if (operator == null){
            leftOperand = rightOperand;
            rightOperand = 0;
        } else {
            calculate();
        }
        operator = op;
    }

    public void doEqual(){
        if (operator != null) {
            calculate();
            rightOperand = leftOperand;
            operator = null;
        }
    }

    private void calculate(){
        if (operator == Operator.ADD){
            leftOperand = leftOperand + rightOperand;
        } else if (operator == Operator.SUBTRACT){
            leftOperand = leftOperand - rightOperand;
        } else if (operator == Operator.MULTIPLY){
            leftOperand = leftOperand * rightOperand;
        } else if (operator == Operator.DIVIDE){
            leftOperand = leftOperand / rightOperand;
        }
        rightOperand = 0;
    }

    public String getDisplayedText(){
        if (operator != null){
            return leftOperand + operator.toString() + rightOperand;
        } else {
            return "" + rightOperand;
        }
    }

    public void onSaveInstanceState(Bundle outState) {
        outState.putInt("leftOperand", leftOperand);
        outState.putInt("rightOperand", rightOperand);
        char op = (operator == null) ? ' ' : operator.getOpChar();
        outState.putChar("operator", op);
    }
}
